#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include <float.h>
#include <math.h>


extern void talking(unsigned char * sampledata,  int samplelength);
extern void talking2(unsigned char * sampledata,  int samplelength);
extern int cpuspeedtest(void);
extern void setspeakerdata(int sample_rate);

int main(argc, argv)
 char *argv[];
 int argc;
 {
 unsigned char * buffer;
 int volume_table[256];
 char fname[80];
 int i,j,k;
 int idx, idx2, wavelth;
 char dbplay = 0, nonverbose=0;
 int  volume=128;
 int  srate=11025;
 
 FILE *fp;
 size_t  iosize, blocksize, memorysize;

 fname[0] = 0;

 if(argc > 1)
   for(i=1; i<argc; i++)
    switch(*argv[i])
     {
	case '/':
	case '-':
	switch(*(argv[i]+1))
	 {
	  case 'v' :
	  case 'V' :
	   volume = atoi(argv[i]+2);
	   break;
	  case 'f' :
	  case 'F' :
	   srate=atoi(argv[i]+2);
	   if(srate>=50000) srate = 50000;
	   else if(srate <1000) srate = 1000;
	   break;
	  case 'd' :
	  case 'D' :
	   dbplay = 1;
	   break;
	  
	  case 'n' :
	  case 'N' :
	   nonverbose=1;
	   break;
	  
	  default:
	    if(!nonverbose) {
		fprintf(stderr, "\nSpeaking32 for IBM PC Speaker V1.0");
		fprintf(stderr, "\n  06/08/1997, Yang YuDong, TsingHua Univ.");
		fprintf(stderr, "\nUsage:  talking [options] [datafile]");
		fprintf(stderr, "\n   --> datafile can only be 8 bits sound files."); 
		fprintf(stderr, "\nOptions:");
		fprintf(stderr, "\n          /? /H : Display this help message");
		fprintf(stderr, "\n             /Fn: Set sample rate to n (1000<n<50000, default is 11025)");
		fprintf(stderr, "\n             /Vn: Set volume to n (0<n<255, default is 128)");
		fprintf(stderr, "\n             /D : Enable double sample rate play back");
		fprintf(stderr, "\n             /N : Disable message output when playing\n");
		return (1);
	    }
	    return (1);
	 }
	break;
	default:
	strcpy(fname, argv[i]);
	break;
     }

 while(!fname[0]) {
    if(nonverbose) return(1);
    fprintf(stderr, "\nInput data file name :");
    gets(fname);
  }

 fp=fopen(fname, "rb");
 if(fp==NULL)
  {
   if(!nonverbose) fprintf(stderr, "  Can not open file: %s\n", fname);
   return (2);
  }
 fseek(fp, 0L, SEEK_END);
 wavelth = ftell(fp); 
 fseek(fp, 0L, SEEK_SET);

 if(! nonverbose)  fprintf(stderr, "  Sound length is %d.%02d seconds (%dkb).\n", wavelth/srate, (wavelth%srate)*100/srate, (wavelth+1023)/1024);

 memorysize = wavelth;  
 while(memorysize > 0 ) {
   buffer=malloc(memorysize);
   if(buffer == NULL)  memorysize -= 4096;
   else break;
  }
 if(buffer == NULL)
  {
   if(! nonverbose)
	fprintf(stderr, "  Can not allocate memory!\n");
   fclose(fp);
   return(3);
  }
 else if(! nonverbose)
	fprintf(stderr, "  %dk byte memory allocated.\n", (memorysize+1023)/1024);

 blocksize = memorysize;
   
 
 if(dbplay) srate *= 2;

 if(! nonverbose) {
   fprintf(stderr, "  CPU Speed Test : loop counter for %dHz sample rate = %d\n",srate,
     (int)(1193180.0*50000.0/(double)srate/(-(double)cpuspeedtest())));
  }
 setspeakerdata(srate);
 
 if(volume < 128) 
     for(i=0; i<256;  i++) 
	 volume_table[i] = (long)(i-128)*volume/128+128;
 else if(volume > 128) {
     for(i=0; i<volume-128; i++) 
	  volume_table[i] = 0;
     for(; i<256+128-volume; i++) 
	   volume_table[i] = (long)(i+128-volume)*128L/(256-volume);
     for(; i<256; i++) 
	  volume_table[i] = 255;
   }

   if(! nonverbose)
     fprintf(stderr, "Playing now, press <ESC> to stop...\n");
   do {
     iosize = fread(buffer, 1, blocksize, fp);
     if(iosize>0) {
	 if(volume != 128) for(idx=0; idx<iosize; idx++) buffer[idx] = volume_table[buffer[idx]];
	 if(dbplay)
	   talking2(buffer, iosize);
	 else  
	   talking(buffer, iosize);
     }
   } while(iosize>0 && (!kbhit() || getch() != 27));
   fclose(fp);
   if(! nonverbose)
     if(iosize==0)  fprintf(stderr, " Recording stoped normally.\n");
     else    fprintf(stderr, " Recording stoped by user.\n");

 free(buffer);
 return(0);
}

